diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSetToolbar.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSetToolbar.jsx
new file mode 100644
index 000000000..e51e2ad5a
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSetToolbar.jsx
@@ -0,0 +1,170 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React, {useContext, useCallback, useEffect, useState} from 'react';
+import { makeStyles } from '@material-ui/styles';
+import { Box } from '@material-ui/core';
+import { PgButtonGroup, PgIconButton } from '../../../../../../static/js/components/Buttons';
+import KeyboardArrowDownIcon from '@material-ui/icons/KeyboardArrowDown';
+import PlaylistAddRoundedIcon from '@material-ui/icons/PlaylistAddRounded';
+import FileCopyRoundedIcon from '@material-ui/icons/FileCopyRounded';
+import DeleteRoundedIcon from '@material-ui/icons/DeleteRounded';
+import { PasteIcon, SaveDataIcon } from '../../../../../../static/js/components/ExternalIcon';
+import GetAppRoundedIcon from '@material-ui/icons/GetAppRounded';
+import {QUERY_TOOL_EVENTS} from '../QueryToolConstants';
+import { QueryToolContext, QueryToolEventsContext } from '../QueryToolComponent';
+import { PgMenu, PgMenuItem } from '../../../../../../static/js/components/Menu';
+import gettext from 'sources/gettext';
+import { useKeyboardShortcuts } from '../../../../../../static/js/custom_hooks';
+import {shortcut_key} from 'sources/keyboard_shortcuts';
+import CopyData from '../QueryToolDataGrid/CopyData';
+import PropTypes from 'prop-types';
+import CustomPropTypes from '../../../../../../static/js/custom_prop_types';
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    padding: '2px',
+    display: 'flex',
+    alignItems: 'center',
+    gap: '4px',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    ...theme.mixins.panelBorder.bottom,
+  },
+}));
+
+export function ResultSetToolbar({containerRef, canEdit}) {
+  const classes = useStyles();
+  const eventBus = useContext(QueryToolEventsContext);
+  const queryToolCtx = useContext(QueryToolContext);
+
+  const [buttonsDisabled, setButtonsDisabled] = useState({
+    'save-data': true,
+    'delete-rows': true,
+    'copy-rows': true,
+  });
+  const [menuOpenId, setMenuOpenId] = React.useState(null);
+  const [checkedMenuItems, setCheckedMenuItems] = React.useState({});
+  /* Menu button refs */
+  const copyMenuRef = React.useRef(null);
+
+  const queryToolPref = queryToolCtx.preferences.sqleditor;
+
+  const setDisableButton = useCallback((name, disable=true)=>{
+    setButtonsDisabled((prev)=>({...prev, [name]: disable}));
+  }, []);
+  const saveData = useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_SAVE_DATA);
+  }, []);
+  const deleteRows = useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_DELETE_ROWS);
+  }, []);
+  const pasteRows = useCallback(async ()=>{
+    let copyUtils = new CopyData({
+      quoting: queryToolPref.results_grid_quoting,
+      quote_char: queryToolPref.results_grid_quote_char,
+      field_separator: queryToolPref.results_grid_field_separator,
+    });
+    let copiedRows = copyUtils.getCopiedRows();
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_ADD_ROWS, copiedRows);
+  }, [queryToolPref]);
+  const copyData = ()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.COPY_DATA, checkedMenuItems['copy_with_headers']);
+  };
+  const addRow = useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_ADD_ROWS, [[]]);
+  }, []);
+  const downloadResult = useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_SAVE_RESULTS);
+  }, []);
+
+  const openMenu = useCallback((e)=>{
+    setMenuOpenId(e.currentTarget.name);
+  }, []);
+  const handleMenuClose = useCallback(()=>{
+    setMenuOpenId(null);
+  }, []);
+
+  const checkMenuClick = useCallback((e)=>{
+    setCheckedMenuItems((prev)=>{
+      let newVal = !prev[e.value];
+      return {
+        ...prev,
+        [e.value]: newVal,
+      };
+    });
+  }, []);
+
+  useEffect(()=>{
+    eventBus.registerListener(QUERY_TOOL_EVENTS.DATAGRID_CHANGED, (isDirty)=>{
+      setDisableButton('save-data', !isDirty);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.SELECTED_ROWS_COLS_CHANGED, (rows, cols)=>{
+      setDisableButton('delete-rows', !rows);
+      setDisableButton('copy-rows', (!rows && !cols));
+    });
+  }, []);
+
+  useEffect(()=>{
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TRIGGER_COPY_DATA, copyData);
+    return ()=>eventBus.deregisterListener(QUERY_TOOL_EVENTS.TRIGGER_COPY_DATA, copyData);
+  }, [checkedMenuItems['copy_with_headers']]);
+
+  useKeyboardShortcuts([
+    {
+      shortcut: queryToolPref.save_data,
+      options: {
+        callback: ()=>{saveData();}
+      }
+    },
+    {
+      shortcut: queryToolPref.download_results,
+      options: {
+        callback: (e)=>{e.preventDefault(); downloadResult();}
+      }
+    },
+  ], containerRef);
+
+  return (
+    <>
+      <Box className={classes.root}>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Add row')} icon={<PlaylistAddRoundedIcon style={{height: 'unset'}}/>}
+            accesskey={shortcut_key(queryToolPref.btn_add_row)} disabled={!canEdit} onClick={addRow} />
+          <PgIconButton title={gettext('Copy')} icon={<FileCopyRoundedIcon />}
+            accesskey={shortcut_key(queryToolPref.btn_copy_row)} disabled={buttonsDisabled['copy-rows']} onClick={copyData} />
+          <PgIconButton title={gettext('Copy options')} icon={<KeyboardArrowDownIcon />} splitButton
+            name="menu-copyheader" ref={copyMenuRef} onClick={openMenu} />
+          <PgIconButton title={gettext('Paste')} icon={<PasteIcon />}
+            accesskey={shortcut_key(queryToolPref.btn_paste_row)} disabled={!canEdit} onClick={pasteRows} />
+          <PgIconButton title={gettext('Delete')} icon={<DeleteRoundedIcon />}
+            accesskey={shortcut_key(queryToolPref.btn_delete_row)} disabled={buttonsDisabled['delete-rows'] || !canEdit} onClick={deleteRows} />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Save Data Changes')} icon={<SaveDataIcon />}
+            shortcut={queryToolPref.save_data} disabled={buttonsDisabled['save-data'] || !canEdit} onClick={saveData}/>
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Save results to file')} icon={<GetAppRoundedIcon />}
+            onClick={downloadResult} shortcut={queryToolPref.download_results}/>
+        </PgButtonGroup>
+      </Box>
+      <PgMenu
+        anchorRef={copyMenuRef}
+        open={menuOpenId=='menu-copyheader'}
+        onClose={handleMenuClose}
+      >
+        <PgMenuItem hasCheck value="copy_with_headers" checked={checkedMenuItems['copy_with_headers']} onClick={checkMenuClick}>Copy with headers</PgMenuItem>
+      </PgMenu>
+    </>
+  );
+}
+
+ResultSetToolbar.propTypes = {
+  containerRef: CustomPropTypes.ref,
+  canEdit: PropTypes.bool,
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/StatusBar.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/StatusBar.jsx
new file mode 100644
index 000000000..df562884e
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/StatusBar.jsx
@@ -0,0 +1,117 @@
+
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React, { useEffect, useState, useContext }  from 'react';
+import { makeStyles } from '@material-ui/styles';
+import { Box } from '@material-ui/core';
+import clsx from 'clsx';
+import _ from 'lodash';
+import { QUERY_TOOL_EVENTS } from '../QueryToolConstants';
+import { useStopwatch } from '../../../../../../static/js/custom_hooks';
+import { QueryToolEventsContext } from '../QueryToolComponent';
+
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    display: 'flex',
+    alignItems: 'center',
+    ...theme.mixins.panelBorder.top,
+    flexWrap: 'wrap',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    userSelect: 'text',
+  },
+  padding: {
+    padding: '2px 12px',
+  },
+  divider: {
+    ...theme.mixins.panelBorder.right,
+  },
+  mlAuto: {
+    marginLeft: 'auto',
+  }
+}));
+
+export function StatusBar() {
+  const classes = useStyles();
+  const eventBus = useContext(QueryToolEventsContext);
+  const [position, setPosition] = useState([1, 1]);
+  const [lastTaskText, setLastTaskText] = useState(null);
+  const [rowsCount, setRowsCount] = useState([0, 0]);
+  const [selectedRowsCount, setSelectedRowsCount] = useState(0);
+  const [dataRowChangeCounts, setDataRowChangeCounts] = useState({
+    isDirty: false,
+    added: 0,
+    updated: 0,
+    deleted: 0,
+  });
+  const {seconds, minutes, hours, msec, start:startTimer, pause:pauseTimer, reset:resetTimer} = useStopwatch({});
+
+  useEffect(()=>{
+    eventBus.registerListener(QUERY_TOOL_EVENTS.CURSOR_ACTIVITY, (newPos)=>{
+      setPosition(newPos||[1, 1]);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.EXECUTION_END, ()=>{
+      pauseTimer();
+      setLastTaskText('Query complete');
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TASK_START, (taskText, startTime)=>{
+      resetTimer();
+      startTimer(startTime);
+      setLastTaskText(taskText);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TASK_END, (taskText, endTime)=>{
+      pauseTimer(endTime);
+      setLastTaskText(taskText);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.ROWS_FETCHED, (fetched, total)=>{
+      setRowsCount([fetched||0, total||0]);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.SELECTED_ROWS_COLS_CHANGED, (rows)=>{
+      setSelectedRowsCount(rows);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.DATAGRID_CHANGED, (_isDirty, dataChangeStore)=>{
+      setDataRowChangeCounts({
+        added: Object.keys(dataChangeStore.added||{}).length,
+        updated: Object.keys(dataChangeStore.updated||{}).length,
+        deleted: Object.keys(dataChangeStore.deleted||{}).length,
+      });
+    });
+  }, []);
+
+  let stagedText = '';
+  if(dataRowChangeCounts.added > 0) {
+    stagedText += ` Added: ${dataRowChangeCounts.added};`;
+  }
+  if(dataRowChangeCounts.updated > 0) {
+    stagedText += ` Updated: ${dataRowChangeCounts.updated};`;
+  }
+  if(dataRowChangeCounts.deleted > 0) {
+    stagedText += ` Deleted: ${dataRowChangeCounts.deleted};`;
+  }
+
+  return (
+    <Box className={classes.root}>
+      <Box className={clsx(classes.padding, classes.divider)}>Total rows: {rowsCount[0]} of {rowsCount[1]}</Box>
+      {lastTaskText &&
+        <Box className={clsx(classes.padding, classes.divider)}>{lastTaskText} {hours.toString().padStart(2, '0')}:{minutes.toString().padStart(2, '0')}:{seconds.toString().padStart(2, '0')}.{msec.toString().padStart(3, '0')}</Box>
+      }
+      {!lastTaskText && !_.isNull(lastTaskText) &&
+        <Box className={clsx(classes.padding, classes.divider)}>{lastTaskText} {hours.toString().padStart(2, '0')}:{minutes.toString().padStart(2, '0')}:{seconds.toString().padStart(2, '0')}.{msec.toString().padStart(3, '0')}</Box>
+      }
+      {Boolean(selectedRowsCount) &&
+        <Box className={clsx(classes.padding, classes.divider)}>Rows selected: {selectedRowsCount}</Box>}
+      {stagedText &&
+        <Box className={clsx(classes.padding, classes.divider)}>
+          <span>Changes staged: {stagedText}</span>
+        </Box>
+      }
+      <Box className={clsx(classes.padding, classes.mlAuto)}>Ln {position[0]}, Col {position[1]}</Box>
+    </Box>
+  );
+}
diff --git a/web/pgadmin/tools/sqleditor/static/js/index.js b/web/pgadmin/tools/sqleditor/static/js/index.js
new file mode 100644
index 000000000..6ad35fb34
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/index.js
@@ -0,0 +1,26 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import pgAdmin from 'sources/pgadmin';
+import pgBrowser from 'top/browser/static/js/browser';
+import SQLEditor from './SQLEditorModule';
+
+/* eslint-disable */
+/* This is used to change publicPath of webpack at runtime for loading chunks */
+/* Do not add let, var, const to this variable */
+__webpack_public_path__ = window.resourceBasePath;
+/* eslint-enable */
+
+if(!pgAdmin.Tools) {
+  pgAdmin.Tools = {};
+}
+pgAdmin.Tools.SQLEditor = SQLEditor.getInstance(pgAdmin, pgBrowser);
+
+module.exports = {
+  SQLEditor: SQLEditor,
+};
diff --git a/web/pgadmin/tools/datagrid/static/js/show_query_tool.js b/web/pgadmin/tools/sqleditor/static/js/show_query_tool.js
similarity index 64%
rename from web/pgadmin/tools/datagrid/static/js/show_query_tool.js
rename to web/pgadmin/tools/sqleditor/static/js/show_query_tool.js
index 157db3335..2f677d7d2 100644
--- a/web/pgadmin/tools/datagrid/static/js/show_query_tool.js
+++ b/web/pgadmin/tools/sqleditor/static/js/show_query_tool.js
@@ -9,7 +9,7 @@
 
 import gettext from '../../../../static/js/gettext';
 import url_for from '../../../../static/js/url_for';
-import {getPanelTitle} from './datagrid_panel_title';
+import {getPanelTitle} from './sqleditor_title';
 import {getRandomInt} from 'sources/utils';
 import $ from 'jquery';
 import Notify from '../../../../static/js/helpers/Notifier';
@@ -18,18 +18,20 @@ function hasDatabaseInformation(parentData) {
   return parentData.database;
 }
 
-function generateUrl(trans_id, title, parentData, sqlId) {
-  let url_endpoint = url_for('datagrid.panel', {
+export function generateUrl(trans_id, parentData, sqlId) {
+  let url_endpoint = url_for('sqleditor.panel', {
     'trans_id': trans_id,
   });
 
   url_endpoint += `?is_query_tool=${true}`
     +`&sgid=${parentData.server_group._id}`
-    +`&sid=${parentData.server._id}`
-    +`&server_type=${parentData.server.server_type}`;
+    +`&sid=${parentData.server._id}`;
 
   if (hasDatabaseInformation(parentData)) {
     url_endpoint += `&did=${parentData.database._id}`;
+    if(parentData.database.label) {
+      url_endpoint += `&database_name=${parentData.database.label}`;
+    }
   }
 
   if(sqlId) {
@@ -47,7 +49,7 @@ function generateTitle(pgBrowser, aciTreeIdentifier) {
   return getPanelTitle(pgBrowser, aciTreeIdentifier);
 }
 
-export function showQueryTool(datagrid, pgBrowser, url, aciTreeIdentifier, transId) {
+export function showQueryTool(queryToolMod, pgBrowser, url, aciTreeIdentifier, transId) {
   const sURL = url || '';
   const queryToolTitle = generateTitle(pgBrowser, aciTreeIdentifier);
 
@@ -66,15 +68,15 @@ export function showQueryTool(datagrid, pgBrowser, url, aciTreeIdentifier, trans
     return;
   }
 
-  const gridUrl = generateUrl(transId, queryToolTitle, parentData);
-  launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, sURL);
+  const gridUrl = generateUrl(transId, parentData);
+  launchQueryTool(queryToolMod, transId, gridUrl, queryToolTitle, sURL);
 }
 
-export function generateScript(parentData, datagrid) {
+export function generateScript(parentData, queryToolMod) {
   const queryToolTitle = `${parentData.database}/${parentData.user}@${parentData.server}`;
   const transId = getRandomInt(1, 9999999);
 
-  let url_endpoint = url_for('datagrid.panel', {
+  let url_endpoint = url_for('sqleditor.panel', {
     'trans_id': transId,
   });
 
@@ -82,12 +84,13 @@ export function generateScript(parentData, datagrid) {
     +`&sgid=${parentData.sgid}`
     +`&sid=${parentData.sid}`
     +`&server_type=${parentData.stype}`
-    +`&did=${parentData.did}`;
+    +`&did=${parentData.did}`
+    +`&sql_id=${parentData.sql_id}`;
 
-  launchDataGrid(datagrid, transId, url_endpoint, queryToolTitle, '');
+  launchQueryTool(queryToolMod, transId, url_endpoint, queryToolTitle, '');
 }
 
-export function showERDSqlTool(parentData, erdSqlId, queryToolTitle, datagrid) {
+export function showERDSqlTool(parentData, erdSqlId, queryToolTitle, queryToolMod) {
   const transId = getRandomInt(1, 9999999);
   parentData = {
     server_group: {
@@ -102,12 +105,12 @@ export function showERDSqlTool(parentData, erdSqlId, queryToolTitle, datagrid) {
     },
   };
 
-  const gridUrl = generateUrl(transId, queryToolTitle, parentData, erdSqlId);
-  launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, '');
+  const gridUrl = generateUrl(transId, parentData, erdSqlId);
+  launchQueryTool(queryToolMod, transId, gridUrl, queryToolTitle, '');
 }
 
-export function launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, sURL) {
-  let retVal = datagrid.launch_grid(transId, gridUrl, true, queryToolTitle, sURL);
+export function launchQueryTool(queryToolMod, transId, gridUrl, queryToolTitle, sURL) {
+  let retVal = queryToolMod.launch(transId, gridUrl, true, queryToolTitle, sURL);
 
   if(!retVal) {
     Notify.alert(
@@ -119,23 +122,17 @@ export function launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, sURL)
   }
 }
 
-function setPanelTitle(panel, value) {
-  if(value) {
-    $('#' + panel.$title.index() + ' div:first').addClass('wcPanelTab-dynamic');
-  } else {
-    $('#' + panel.$title.index() + ' div:first').removeClass('wcPanelTab-dynamic');
-  }
-}
-
 export function _set_dynamic_tab(pgBrowser, value){
-  var datagrid_panels = pgBrowser.docker.findPanels('frm_datagrid');
-  datagrid_panels.forEach(panel => {
-    setPanelTitle(panel, value);
-  });
+  var sqleditor_panels = pgBrowser.docker.findPanels('frm_sqleditor');
+  const process = panel => {
+    if(value) {
+      $('#' + panel.$title.index() + ' div:first').addClass('wcPanelTab-dynamic');
+    } else {
+      $('#' + panel.$title.index() + ' div:first').removeClass('wcPanelTab-dynamic');
+    }
+  };
+  sqleditor_panels.forEach(process);
 
   var debugger_panels = pgBrowser.docker.findPanels('frm_debugger');
-  debugger_panels.forEach(panel => {
-    setPanelTitle(panel, value);
-  });
-
+  debugger_panels.forEach(process);
 }
diff --git a/web/pgadmin/tools/datagrid/static/js/show_data.js b/web/pgadmin/tools/sqleditor/static/js/show_view_data.js
similarity index 87%
rename from web/pgadmin/tools/datagrid/static/js/show_data.js
rename to web/pgadmin/tools/sqleditor/static/js/show_view_data.js
index f418e7da7..a76fd5f15 100644
--- a/web/pgadmin/tools/datagrid/static/js/show_data.js
+++ b/web/pgadmin/tools/sqleditor/static/js/show_view_data.js
@@ -8,24 +8,24 @@
 //////////////////////////////////////////////////////////////
 import gettext from '../../../../static/js/gettext';
 import url_for from '../../../../static/js/url_for';
-import {getDatabaseLabel, generateTitle} from './datagrid_panel_title';
+import {getDatabaseLabel, generateTitle} from './sqleditor_title';
 import CodeMirror from 'bundled_codemirror';
 import * as SqlEditorUtils from 'sources/sqleditor_utils';
 import $ from 'jquery';
 import _ from 'underscore';
 import Notify from '../../../../static/js/helpers/Notifier';
 
-export function showDataGrid(
-  datagrid,
+export function showViewData(
+  queryToolMod,
   pgBrowser,
   alertify,
   connectionData,
-  aciTreeIdentifier,
+  treeIdentifier,
   transId,
   filter=false,
   preferences=null
 ) {
-  const node = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
+  const node = pgBrowser.tree.findNodeByDomElement(treeIdentifier);
   if (node === undefined || !node.getData()) {
     Notify.alert(
       gettext('Data Grid Error'),
@@ -34,7 +34,7 @@ export function showDataGrid(
     return;
   }
 
-  const parentData = pgBrowser.tree.getTreeNodeHierarchy(  aciTreeIdentifier
+  const parentData = pgBrowser.tree.getTreeNodeHierarchy(  treeIdentifier
   );
 
   if (hasServerOrDatabaseConfiguration(parentData)
@@ -48,30 +48,33 @@ export function showDataGrid(
   }
 
   const gridUrl = generateUrl(transId, connectionData, node.getData(), parentData);
-  const queryToolTitle = generateDatagridTitle(pgBrowser, aciTreeIdentifier);
+  const queryToolTitle = generateViewDataTitle(pgBrowser, treeIdentifier);
   if(filter) {
     initFilterDialog(alertify, pgBrowser);
 
     const validateUrl = generateFilterValidateUrl(node.getData(), parentData);
 
     let okCallback = function(sql) {
-      datagrid.launch_grid(transId, gridUrl, false, queryToolTitle, null, sql);
+      queryToolMod.launch(transId, gridUrl, false, queryToolTitle, null, sql);
     };
 
-    $.get(url_for('datagrid.filter'),
+    $.get(url_for('sqleditor.filter'),
       function(data) {
         alertify.filterDialog(gettext('Data Filter - %s', queryToolTitle), data, validateUrl, preferences, okCallback)
           .resizeTo(pgBrowser.stdW.sm,pgBrowser.stdH.sm);
       }
     );
   } else {
-    datagrid.launch_grid(transId, gridUrl, false, queryToolTitle);
+    queryToolMod.launch(transId, gridUrl, false, queryToolTitle);
   }
 }
 
 
 export function retrieveNameSpaceName(parentData) {
-  if (parentData.schema !== undefined) {
+  if(!parentData) {
+    return null;
+  }
+  else if (parentData.schema !== undefined) {
     return parentData.schema.label;
   }
   else if (parentData.view !== undefined) {
@@ -83,8 +86,24 @@ export function retrieveNameSpaceName(parentData) {
   return '';
 }
 
+export function retrieveNodeName(parentData) {
+  if(!parentData) {
+    return null;
+  }
+  else if (parentData.table !== undefined) {
+    return parentData.table.label;
+  }
+  else if (parentData.view !== undefined) {
+    return parentData.view.label;
+  }
+  else if (parentData.catalog !== undefined) {
+    return parentData.catalog.label;
+  }
+  return '';
+}
+
 function generateUrl(trans_id, connectionData, nodeData, parentData) {
-  let url_endpoint = url_for('datagrid.panel', {
+  let url_endpoint = url_for('sqleditor.panel', {
     'trans_id': trans_id,
   });
 
@@ -108,7 +127,7 @@ function generateFilterValidateUrl(nodeData, parentData) {
     'obj_id': nodeData._id,
   };
 
-  return url_for('datagrid.filter_validate', url_params);
+  return url_for('sqleditor.filter_validate', url_params);
 }
 
 function initFilterDialog(alertify, pgBrowser) {
@@ -286,15 +305,15 @@ function hasSchemaOrCatalogOrViewInformation(parentData) {
     parentData.catalog !== undefined;
 }
 
-export function generateDatagridTitle(pgBrowser, aciTreeIdentifier, custom_title=null, backend_entity=null) {
+export function generateViewDataTitle(pgBrowser, treeIdentifier, custom_title=null, backend_entity=null) {
   var preferences = pgBrowser.get_preferences_for_module('browser');
   const parentData = pgBrowser.tree.getTreeNodeHierarchy(
-    aciTreeIdentifier
+    treeIdentifier
   );
 
   const namespaceName = retrieveNameSpaceName(parentData);
   const db_label = !_.isUndefined(backend_entity) && backend_entity != null && backend_entity.hasOwnProperty('db_name') ? backend_entity['db_name'] : getDatabaseLabel(parentData);
-  const node = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
+  const node = pgBrowser.tree.findNodeByDomElement(treeIdentifier);
 
   var dtg_title_placeholder = '';
   if(custom_title) {
@@ -310,7 +329,7 @@ export function generateDatagridTitle(pgBrowser, aciTreeIdentifier, custom_title
     'server': parentData.server.label,
     'schema': namespaceName,
     'table': node.getData().label,
-    'type': 'datagrid',
+    'type': 'view_data',
   };
   return generateTitle(dtg_title_placeholder, title_data);
 }
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor_title.js
similarity index 58%
rename from web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
rename to web/pgadmin/tools/sqleditor/static/js/sqleditor_title.js
index 7f5d6fbe2..93bd0d015 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor_title.js
@@ -8,8 +8,9 @@
 //////////////////////////////////////////////////////////////
 
 import gettext from 'sources/gettext';
+import Alertify from 'pgadmin.alertifyjs';
 import pgWindow from 'sources/window';
-import Notify from '../../../../static/js/helpers/Notifier';
+import { retrieveNameSpaceName, retrieveNodeName } from './show_view_data';
 
 const pgAdmin = pgWindow.pgAdmin;
 
@@ -22,6 +23,25 @@ function isServerInformationAvailable(parentData) {
   return parentData.server === undefined;
 }
 
+export function getTitle(pgAdmin, browserPref, parentData=null, isConnTitle=false, server=null, database=null, username=null, isQueryTool=true) {
+  let titleTemplate = isQueryTool ? pgAdmin['qt_default_placeholder'] : pgAdmin['vw_edt_default_placeholder'];
+  if (!isConnTitle) {
+    if(!isQueryTool) {
+      titleTemplate = browserPref['vw_edt_tab_title_placeholder'] ?? pgAdmin['qt_default_placeholder'];
+    } else {
+      titleTemplate = browserPref['qt_tab_title_placeholder'] ?? pgAdmin['vw_edt_default_placeholder'];
+    }
+  }
+  return generateTitle(titleTemplate, {
+    'database': database,
+    'username': username,
+    'server': server,
+    'schema': retrieveNameSpaceName(parentData),
+    'table': retrieveNodeName(parentData),
+    'type': isQueryTool ? 'query_tool' : 'view_data',
+  });
+}
+
 export function getPanelTitle(pgBrowser, selected_item=null, custom_title=null, parentData=null, conn_title=false, db_label=null) {
   var preferences = pgBrowser.get_preferences_for_module('browser');
   if(selected_item == null && parentData == null) {
@@ -57,6 +77,7 @@ export function getPanelTitle(pgBrowser, selected_item=null, custom_title=null,
     'server': parentData.server.label,
     'type': 'query_tool',
   };
+
   return generateTitle(qt_title_placeholder, title_data);
 }
 
@@ -69,7 +90,7 @@ export function setQueryToolDockerTitle(panel, is_query_tool, panel_title, is_fi
     panel_tooltip = gettext('File - ') + panel_title;
     panel_icon = 'fa fa-file-alt';
   }
-  else if (is_query_tool == 'false' || is_query_tool == false) {
+  else if (is_query_tool == 'false' || !is_query_tool) {
     // Edit grid titles
     panel_tooltip = gettext('View/Edit Data - ') + panel_title;
     panel_icon = 'pg-font-icon icon-view_data';
@@ -86,33 +107,29 @@ export function setQueryToolDockerTitle(panel, is_query_tool, panel_title, is_fi
 
 export function set_renamable_option(panel, is_file) {
   if(is_file || is_file == 'true') {
-    panel.renamable(false);
+    panel?.renamable(false);
   } else {
-    panel.renamable(true);
+    panel?.renamable(true);
   }
 }
 
 export function generateTitle(title_placeholder, title_data) {
 
-  if(title_data.type == 'query_tool') {
-    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
-    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
-    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
-  } else if(title_data.type == 'datagrid') {
-    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
-    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
-    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
-    title_placeholder = title_placeholder.replace(new RegExp('%SCHEMA%'), _.unescape(title_data.schema));
-    title_placeholder = title_placeholder.replace(new RegExp('%TABLE%'), _.unescape(title_data.table));
+  if(title_data.type == 'query_tool' || title_data.type == 'psql_tool') {
+    title_placeholder = title_placeholder.replace('%DATABASE%', _.unescape(title_data.database));
+    title_placeholder = title_placeholder.replace('%USERNAME%', _.unescape(title_data.username));
+    title_placeholder = title_placeholder.replace('%SERVER%', _.unescape(title_data.server));
+  } else if(title_data.type == 'view_data') {
+    title_placeholder = title_placeholder.replace('%DATABASE%', _.unescape(title_data.database));
+    title_placeholder = title_placeholder.replace('%USERNAME%', _.unescape(title_data.username));
+    title_placeholder = title_placeholder.replace('%SERVER%', _.unescape(title_data.server));
+    title_placeholder = title_placeholder.replace('%SCHEMA%', _.unescape(title_data.schema));
+    title_placeholder = title_placeholder.replace('%TABLE%', _.unescape(title_data.table));
   } else if(title_data.type == 'debugger') {
-    title_placeholder = title_placeholder.replace(new RegExp('%FUNCTION%'), _.unescape(title_data.function_name));
-    title_placeholder = title_placeholder.replace(new RegExp('%ARGS%'), _.unescape(title_data.args));
-    title_placeholder = title_placeholder.replace(new RegExp('%SCHEMA%'), _.unescape(title_data.schema));
-    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
-  } else if(title_data.type == 'psql_tool') {
-    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
-    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
-    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
+    title_placeholder = title_placeholder.replace('%FUNCTION%', _.unescape(title_data.function_name));
+    title_placeholder = title_placeholder.replace('%ARGS%', _.unescape(title_data.args));
+    title_placeholder = title_placeholder.replace('%SCHEMA%', _.unescape(title_data.schema));
+    title_placeholder = title_placeholder.replace('%DATABASE%', _.unescape(title_data.database));
   }
 
   return _.escape(title_placeholder);
@@ -122,7 +139,7 @@ export function generateTitle(title_placeholder, title_data) {
  * This function is used refresh the db node after showing alert to the user
  */
 export function refresh_db_node(message, dbNode) {
-  Notify.alert()
+  Alertify.alert()
     .setting({
       'title': gettext('Database moved/renamed'),
       'label':gettext('OK'),
